require 'rubygems'
require 'win32/changenotify'
require 'socket'

class ChangeNotifyServer

  def initialize(dir)
    @dir = dir
    run
  end

  def run()

    puts "run"
    flags = Win32::ChangeNotify::FILE_NAME | Win32::ChangeNotify::DIR_NAME
    flags |= Win32::ChangeNotify::LAST_WRITE

    cn = Win32::ChangeNotify.new(@dir, true, flags)
    loop  {
      # Wait up to 20 seconds for something to happen
      begin
        cn.wait() { |events|
            events.each { |event|
    	           puts "Something changed: #{event.inspect}"
    	           puts "File: " + event.file_name
    	           puts "Action: " + event.action
           }
       }
      rescue => e
       puts "Error: #{e}, #{e.backtrace}"
       cn.close
     end
    }


  end


end

unless ARGV.length == 1
  puts "Usage:"
  puts "server.rb <dir>"
  exit
end

ChangeNotifyServer.new(ARGV[0])
