require 'selenium-webdriver'

require File.join(File.dirname(__FILE__), "testwise_runtime_support.rb")

class TestwiseListener < Selenium::WebDriver::Support::AbstractEventListener
 
  include TestWiseRuntimeSupport

  def before_navigate_to(url, driver)
    perform_driver_operation
  end
  
  def before_find(by, what, driver) 
    perform_driver_operation
  end
  
  def before_execute_script(script, driver)
    perform_driver_operation
  end

  def before_navigate_back(driver)
    perform_driver_operation
  end

  def before_navigate_forward(driver)
    perform_driver_operation
  end

  def before_quit(driver)
    perform_driver_operation
  end

  def before_click(element, driver)
    highlight(element, driver)
  end

  def before_change_value_of(element, driver)
    highlight(element, driver)
  end
  

  private
  
  def perform_driver_operation
    dump_caller_stack
    operation_delay
    check_for_pause
  end
  
  ##
  # Changes background color and outline of element
  # 
  def highlight(element, driver)
    if ENV["TESTWISE_HIGHLIGHT_WEB_CONTROL"] && ENV["TESTWISE_HIGHLIGHT_WEB_CONTROL"] == "true"
      css_text = element.style('cssText')
      duration = 100
      if ENV["TESTWISE_OPERATION_DELAY"] &&  ENV["TESTWISE_OPERATION_DELAY"].to_i > 0
        duration = ENV["TESTWISE_OPERATION_DELAY"].to_i * 10
      end
      
      driver.execute_script('arguments[0].style.cssText += "; background: #FFFF99; outline: 1px solid magenta"', element)
      snippet = <<-JS
        var element = arguments[0], cssText = arguments[1], done = arguments[2];
        setTimeout(function() {
          element.style.cssText = cssText;
          done();
        }, 100)
      JS
      # snippet.gsub("100", duration.to_s);
      driver.manage.timeouts.script_timeout = 1
      driver.execute_async_script(snippet, element, css_text)
    end
  end
  
  
end
