# Enter your step denfitions below

# Once you created the step skeleton (right click from feature file),
# add test steps like below:
#  driver.find_element(:text, "Start here").click
# Then perform refactorings to extract the steps into Page Objects.

Given /^I am signed in as "(.*?)"$/ do |user|
  begin
    driver.find_element(:link, "Login")
    sign_in("agileway", "testwise")
  rescue
    # already logged in
    driver.navigate.to("#{site_url()}")
  end
end

When /^select oneway trip$/ do
  driver.find_element(:xpath, "//input[@name='tripType' and @value='oneway']").click
end

When /^select return trip$/ do
  driver.find_element(:xpath, "//input[@name='tripType' and @value='return']").click
end

When /^click "(.*?)"$/ do |arg1|
  sleep 0.5
  driver.find_element(:xpath, "//input[@value='Continue']").click
end

When /^select depart from "(.*?)" to "(.*?)" on "(.*?)" of "(.*?)"$/ do |from, to, day, month_year|
  Selenium::WebDriver::Support::Select.new(driver.find_element(:name, "fromPort")).select_by(:text, from)
  Selenium::WebDriver::Support::Select.new(driver.find_element(:name, "toPort")).select_by(:text, to)
  Selenium::WebDriver::Support::Select.new(driver.find_element(:id, "departDay")).select_by(:text, day)
  Selenium::WebDriver::Support::Select.new(driver.find_element(:id, "departMonth")).select_by(:text, month_year)
end

Then /^I should see "(.*?)", "(.*?)" and "(.*?)" on next page$/ do |text1, text2, text3|
  the_page_source = driver.page_source
  expect(the_page_source).to include(text1)
  expect(the_page_source).to include(text2)
  expect(the_page_source).to include(text3)
end

When /^return on "(.*?)" of "(.*?)"$/ do |day, month|
  Selenium::WebDriver::Support::Select.new(driver.find_element(:id, "returnDay")).select_by(:text, day)
  Selenium::WebDriver::Support::Select.new(driver.find_element(:id, "returnMonth")).select_by(:text, month)
end
