require 'rubygems'
require 'selenium-webdriver'
gem "minitest"
# require "minitest/autorun"
require 'minitest/spec'

# include utility functions such as 'page_text', 'try_for', 'fail_safe', ..., etc.
require File.join(File.dirname(__FILE__), "..", "..", "agileway_utils.rb")
include AgilewayUtils

require File.join(File.dirname(__FILE__), "step_helper.rb")
include StepHelper

# load page classes
require File.join(File.dirname(__FILE__), "..","..", "pages", "abstract_page.rb")
Dir["#{File.dirname(__FILE__)}/../../pages/*_page.rb"].each { |file| load file }


$BASE_URL = "https://travel.agileway.net"

def the_browser
  if $TESTWISE_BROWSER then
    $TESTWISE_BROWSER.downcase.to_sym
  elsif ENV["BROWSER"] &&  ENV["BROWSER"].size > 1
    ENV["BROWSER"].downcase.to_sym
  else
    :chrome
  end
end

# a possible issue with Cucumber 4.0, 
# in dry run mode, still invoke new driver instance
unless ENV["CUCUMBER_DRY_RUN"] && ENV["CUCUMBER_DRY_RUN"] == "true"
  driver = Selenium::WebDriver.for(the_browser)
end


World(Minitest::Assertions)

Before do
  @driver = driver
  goto_home_page
end

# before the process ends
at_exit do
  driver.close if driver && !debugging?
end

def debugging?
  if ENV["RUN_IN_TESTWISE"].to_s == "true" && ENV["TESTWISE_RUNNING_AS"] == "test_case"
    return true
  end
  return $TESTWISE_DEBUGGING && $TESTWISE_RUNNING_AS == "test_case"
end

def site_url(default = $BASE_URL)
  # puts("ENV['BASE_URL']: #{ENV['BASE_URL']}")
  $TESTWISE_PROJECT_BASE_URL || ENV["BASE_URL"] || default
end


