var webdriver = require('selenium-webdriver'),
    By = webdriver.By,
    until = webdriver.until;
// var test = require('selenium-webdriver/testing');
var assert = require('assert');

var driver;
const timeOut = 5000;
const site_url = process.env.BASE_URL || 'https://travel.agileway.net';

String.prototype.contains = function(it) {
  return this.indexOf(it) != -1;
};

describe('User Authentication', function() {

  before(async function() {
    this.timeout(timeOut);
    driver = new webdriver.Builder().forBrowser('chrome').build();
    // driver.manage().window().setSize(1024, 700); //  OLD Version
    // driver.manage().window().setPosition(30, 78); // OLD Version
    driver.manage().window().setRect({width: 1027, height: 700, x: 30, y: 78})
  });

  beforeEach(async function() {
    this.timeout(timeOut);
    await driver.get(site_url);
  });

  after(async function() {
    if (!(process.env.RUN_IN_TESTWISE == "true" && process.env.TESTWISE_RUNNING_AS == "test_case")) {
      driver.quit();
    }
  });

  it('Invalid user', async function() {
    this.timeout(timeOut);
    await driver.findElement(webdriver.By.name('username')).sendKeys('agileway');
    await driver.findElement(webdriver.By.name('password')).sendKeys('badpass');
    await driver.findElement(webdriver.By.name('commit')).click();
    await driver.getPageSource().then(function(page_source) {
      assert(page_source.contains("Invalid email or password"))
    });
  });

  it('User can login successfully', async function() {
    this.timeout(timeOut);
    await driver.findElement(webdriver.By.name('username')).sendKeys('agileway');
    await driver.findElement(webdriver.By.name('password')).sendKeys('testwise');
    await driver.findElement(webdriver.By.name('commit')).click();
    await driver.getPageSource().then(function(page_source) {
      assert(page_source.contains("Welcome"))
    });
    await driver.findElement(By.linkText("Sign off")).click();
  });


});
