var webdriver = require('selenium-webdriver'),
    By = webdriver.By,
    until = webdriver.until;
//var test = require('selenium-webdriver/testing');
var assert = require('assert');

var driver;
const timeOut = 10000;
const site_url = process.env.BASE_URL || 'https://travel.agileway.net';

String.prototype.contains = function(it) {
  return this.indexOf(it) != -1;
};

describe('Passenger', function() {

  before(async function() {
    this.timeout(timeOut);
    driver = new webdriver.Builder().forBrowser('chrome').build();
    driver.manage().window().setRect({width: 1027, height: 700, x: 30, y: 78})
    //driver.manage().window().setSize(1024, 700);
    //driver.manage().window().setPosition(30, 78);
  });

  beforeEach(async function() {
    this.timeout(timeOut);
    await driver.get(site_url);
    await driver.findElement(webdriver.By.name('username')).sendKeys('agileway');
    await driver.findElement(webdriver.By.name('password')).sendKeys('testwise');
    await driver.findElement(webdriver.By.name('commit')).click();
  });

  after(async function() {
    if (!(process.env.RUN_IN_TESTWISE == "true" && process.env.TESTWISE_RUNNING_AS == "test_case")) {
      driver.quit();
    }
  });

  it('[4] Can enter passenger details', async function() {
    this.timeout(timeOut);
    await driver.findElement(By.xpath("//input[@name='tripType' and @value='oneway']")).click();
    await driver.findElement(By.name("fromPort")).sendKeys("New York");
    await driver.findElement(By.name("toPort")).sendKeys("Sydney");
    await driver.findElement(By.name("departDay")).sendKeys("02");
    await driver.findElement(By.name("departMonth")).sendKeys("May 2023");
    await driver.findElement(By.xpath("//input[@value='Continue']")).click();

    await driver.findElement(By.xpath("//input[@value='Next']")).click();
    await driver.findElement(By.tagName("body")).getText().then(function(the_page_text) {
      assert(the_page_text.includes("Must provide last name"))
    });

    await driver.findElement(By.name("passengerFirstName")).sendKeys("Bob");
    await driver.findElement(By.name("passengerLastName")).sendKeys("Tester");
    await driver.findElement(By.xpath("//input[@value='Next']")).click();

    await driver.findElement(By.name("holder_name")).getAttribute("value").then(function(val) {
      assert.equal("Bob Tester", val)
    });

  });


});
