require File.join(File.dirname(__FILE__), "abstract_page.rb")

class LoginPage < AbstractPage
  def initialize(driver)
    super(driver, "") # <= TEXT UNIQUE TO THIS PAGE
  end

  def enter_username(user)
    driver.find_element(:id, "username").send_keys(user)
  end

  def enter_password(pass)
    driver.find_element(:id, "password").send_keys(pass)
  end

  def click_sign_in
    driver.find_element(:id, "username").submit
  end

  def login(user, pass)
    enter_username(user)
    enter_password(pass)
    click_sign_in
  end
end
